/*

  File functions, that are compatible with most of ANSI C compatible compilers
  Library is decicated to work independed, no other libraries required.
  Not only file functions included but also many string operations.

*/

#include <jtmstdio.h>

#ifndef __jtmdj_h_included
 #ifndef jtm_getch
  #define jtm_getch getch
 #endif

 #ifndef jgetch
  #define jgetch getch
 #endif
#endif

int jfexist(const char *_fname);
int fexist(const char *_fname);
extern int jdelete(char *_fname);
int xcopy(char *_source,char *_output);
extern long fsizeof(char *_fname);
extern void DumpAscFile(char *filename,void SelectedOutputConsole());

long fsizeof(char *_fname)
{
 //
 long _return;
 FILE *f;

 //
 f=fopen(_fname,"rb");
 if(f==NULL)
 {
  _return=0;
  goto loppu;
 }
 fseek(f,0,SEEK_END);
 _return=ftell(f);
 fclose(f);
loppu:
 return _return;
}

int jrm(char *_fname)
{
 return jdelete(_fname);
}

int jdelete(char *_fname)
{
 char str[255];

 jtm_translatefilename(_fname,str);
 return remove(str);
}

int jtm_query_RetryAbort()
{
 write("(R)etry (A)bort?");
 return jtm_getch();
}

int jtm_query_RetrySkip()
{
 write("(R)etry (S)kip?");
 return jgetch();
}

int jtm_query_YesNo()
{
 write("(Y)es (N)o?");
 return jgetch();
}

/*
 * JTMOS: I-XCOPY, Internal X-copy v1.0, (C)1997 by Jari Tuominen.
 */
int xcopy(char *_source,char *_output)
{
 // Locals
 long ad,ad2;
 unsigned char m1,m2,m3,m4,m5,m6,m7,m8,re;
 FILE *fp,*fp2,*fp3,*fp4;
 char ast[255],ast2[255],ast3[255],ast4[255],
      str[255];

 //
 re=0;

 //
 sprintf(str,"%s -> %s\n\r",_source,_output);
 write(str);

 //
 if(!fexist(_source))
 {
  re=1;
  goto loppu;
 }

 //
 if(fexist(_output))
 {
  write("File exist, would you like to overwrite the file, ");
  m1=jtm_query_YesNo();
  if(m1!='y')
  {
   write(" Skipping ...\n");
   goto loppu;
  }
  write(" Overwriting ...\n");
 }

 //
 ad=fsizeof(_source);
 ad2=0;

 //
 fp=fopen(_source,"rb");
 fp2=fopen(_output,"wb");
 if(fp2==NULL)
 {
  write("Cannot create output file.\n");
  re=1;
  goto loppu;
 }
 do{
  if(ad2>=ad)break;
  //
  if(fp2==NULL)
  {
   sprintf(ast4,"I.XCOPY: File \"%s\" not created.",_output);
   fclose(fp); fclose(fp2);
   break;
  }
  fputc(fgetc(fp),fp2);
  ad2++;
 }while(0==0);
 fclose(fp);
 fclose(fp2);
 if( !fexist(_output) ) re=1;
loppu:
 return re;
}

void jtm_fgetstr(FILE *fp,char *str)
{
 unsigned x,y,xx,yy,x1,y1,x2,y2,ad,ad2,ad3,ad4;
 unsigned char m1,m2,m3,m4,m5,m6,m7,m8;
 FILE *fp2,*fp3,*fp4;
 char str2[255];
 //
/*
   Usage:       F.e. jgetenv uses this routine when it reads
                jtmos.cfg, JTMOS system configuration file.               

   Notice:      Before you start to use this function,
                it's good to notice how the function really works,
                here is a simple example, check this out:

                jtm_fgetstr(fp,str);

   special marks :

    hello world                 Invalid string..

    "hello world"               Very simple string..

    "hello world\n"             String with enter code (0x0d) in end of it

    "cd \"                      Invalid mark

    "cd \\"                     Correct!

 */
//   seektomark('\"',fp);
   do
   {    
    m1=fgetc(fp);
    if(m1!=32)
    {
     if(m1!='\"')
     {
      fscanf(fp,"%s",&str);
      goto loppu;
     }
    }
   }while(m1!='\"');
   x=0;
   do
   {
    m1=fgetc(fp);
    if(m1=='\\')
    {
     m1=fgetc(fp);
     if(m1=='0')
     {
      m1=0x00;
      goto righton;
     }
     if(m1=='n') // Put cursor on new line
     {
      m1=0x0d;
      goto righton;
     }
     if(m1=='r') // Put cursor on left corner
     {
      m1=0x0e;
      goto righton;
     }
     fseek(fp,-2,SEEK_CUR);
     m1=fgetc(fp);
    }
    if(m1=='\"')break;
righton:
    str[x]=m1; x++;
   }while(m1!='\"');
   // Check if after mark '\"' is mark ';',
   // if that isn't true, add 0x0d(Enter) to end of string read before.
   m1=fgetc(fp);
   if(m1!=';')
   {
    str[x]=0x0d; x++;
    goto nextone11;
   }
   else
   {
//    fseek(fp,-1,SEEK_CUR);
   }
   seektoeol(fp);
nextone11:
   //Mark end of string
   str[x]=0;
loppu:
 while(0!=0);
}

void uni_getstr(FILE *fp)
{
 unsigned x,y,xx,yy,x1,y1,x2,y2,ad,ad2,ad3,ad4;
 unsigned char m1,m2,m3,m4,m5,m6,m7,m8;
 FILE *fp2,*fp3,*fp4;
 char str[255],str2[255];
 //
/*
   Usage:       F.e. jgetenv uses this routine when it reads
                jtmos.cfg, JTMOS system configuration file.               

   Notice:      Before you start to use this function,
                it's good to notice how the function really works,
                this is simple example, check this out:

   uni_getstr(fp);
   jtmglvar.h: char str[255];

   It reads string in JTMOS global variable str, system string #1

   special marks :

    hello world                 Invalid string..

    "hello world"               Very simple string..

    "hello world\n"             String with enter code (0x0d) in end of it

    "cd \"                      Invalid mark

    "cd \\"                     Correct!

 */
//   seektomark('\"',fp);
   do
   {    
    m1=fgetc(fp);
    if(m1!=32)
    {
     if(m1!='\"')
     {
      fscanf(fp,"%s",&str);
      goto loppu;
     }
    }
   }while(m1!='\"');
   x=0;
   do
   {
    m1=fgetc(fp);
    if(m1=='\\')
    {
     m1=fgetc(fp);
     if(m1=='0')
     {
      m1=0x00;
      goto righton;
     }
     if(m1=='n') // Put cursor on new line
     {
      m1=0x0d;
      goto righton;
     }
     if(m1=='r') // Put cursor on left corner
     {
      m1=0x0e;
      goto righton;
     }
     fseek(fp,-2,SEEK_CUR);
     m1=fgetc(fp);
    }
    if(m1=='\"')break;
righton:
    str[x]=m1; x++;
   }while(m1!='\"');
   // Check if after mark '\"' is mark ';',
   // if that isn't true, add 0x0d(Enter) to end of string read before.
   m1=fgetc(fp);
   if(m1!=';')
   {
    str[x]=0x0d; x++;
    goto nextone11;
   }
   seektoeol(fp);
nextone11:
   //Mark end of string
   str[x]=0;
loppu:
 while(0!=0);
}

void uni_getstri(FILE *_fp)
{
 unsigned x,y,xx,yy,x1,y1,x2,y2,ad,ad2,ad3,ad4;
 unsigned char m1,m2,m3,m4,m5,m6,m7,m8;
 FILE *fp,*fp2,*fp3,*fp4;
 char str[255];
 //
 seektomark('\"',_fp); x=0;
 do
 {
  m1=fgetc(_fp);
  if(m1=='\\')
  {
   m1=fgetc(_fp);
   if(m1=='0')
   {
    m1=0x00;
    goto righton;
   }
   if(m1=='n')
   {
    m1=0x0d;
    goto righton;
   }
  }
  if(m1=='\"')break;
righton:
  str[x]=m1; x++;
 }while(m1!='\"');
nextone11:
 //Mark end of string
 str[x]=0;
}











// Get string, way 1/2
void jtm_getstr(FILE *fp,char *str)
{
 //
 unsigned x,y,xx,yy,x1,y1,x2,y2,ad,ad2,ad3,ad4;
 unsigned char m1,m2,m3,m4,m5,m6,m7,m8;
 FILE *fp2,*fp3,*fp4;
 char str2[255];

 //
   do
   {    
    m1=fgetc(fp);
    if(m1!=32)
    {
     if(m1!='\"')
     {
      fscanf(fp,"%s",&str);
      goto loppu;
     }
    }
   }while(m1!='\"');
   x=0;
   do
   {
rep:
    m1=fgetc(fp);
    if(m1=='\\')
    {
     m1=fgetc(fp);
     if(m1=='\"')
     {
      m1='\"';
      str[x]=m1; x++;
      goto rep;
     }
     if(m1=='0')
     {
      m1=0x00;
      goto righton;
     }
     if(m1=='n') // Put cursor on new line
     {
      m1=0x0d;
      goto righton;
     }
     if(m1=='r') // Put cursor on left corner
     {
      m1=0x0e;
      goto righton;
     }
     fseek(fp,-2,SEEK_CUR);
     m1=fgetc(fp);
    }
    if(m1=='\"')break;
righton:
    str[x]=m1; x++;
   }while(m1!='\"');
   // Check if after mark '\"' is mark ';',
   // if that isn't true, add 0x0d(Enter) to end of string read before.
   m1=fgetc(fp);
   if(m1!=';')
   {
    str[x]=0x0d; x++;
    goto nextone11;
   }
   seektoeol(fp);
nextone11:
   //Mark end of string
   str[x]=0;
loppu:
 while(0!=0);
}

// Get string, way 2/2
void jtm_getstri(FILE *_fp,char *str)
{
 unsigned x,y,xx,yy,x1,y1,x2,y2,ad,ad2,ad3,ad4;
 unsigned char m1,m2,m3,m4,m5,m6,m7,m8;
 FILE *fp,*fp2,*fp3,*fp4;
 char str[255];
 //
 seektomark('\"',_fp); x=0;
 do
 {
rep:
  m1=fgetc(_fp);
  if(m1=='\\')
  {
   m1=fgetc(_fp);
   if(m1=='\"')
   {
    m1='\"';
    str[x]=m1; x++;
    goto rep;
   }
   if(m1=='0')
   {
    m1=0x00;
    goto righton;
   }
   if(m1=='n')
   {
    m1=0x0d;
    goto righton;
   }
  }
  if(m1=='\"')break;
righton:
  str[x]=m1; x++;
 }while(m1!='\"');
nextone11:
 //Mark end of string
 str[x]=0;
}












// JTM_MESSAGEBUFFER function
// --------------------------
//
// This functions is used to report something out when program/system crashes,
// so it is aimed to debug processing, but is also usable with any
// other informating, like silent reporting(doesn't disturb user).
//
void jtm_messagebuffer(char *_message)
{
 /*
  *  C:/JTMOS.MSB       Message buffer, this is the file where all messages
  *                     will be stored, for example JTM_KILLPROCESSS;
  *                     uses this buffer, when it needs to tell user why
  *                     it had to kill the process, or why however called.
  *                     Buffer stays alive even if application/system crashes.
  */
 FILE *_fp;
 long ad,ad2,ad3,ad4;

 //
 _fp=fopen("c:/jtmos.msb","ab");
 fprintf(_fp,"msg%x: \"%s\" \n",systemtimer.counterx,
                                  _message);
 fclose(_fp);
}

int jfindfirst(const char *pathname, struct ffblk *ffblk, int attrib)
{
 //
 int i;
 char str[255],str2[255];

 //
 i=jtm_translatefilename(pathname,str);

 //
 switch(i)
 {
  /*** DLL CASING **/
  case 2:
  ffblk[0].ff_name[250]='d';
  ffblk[0].ff_name[251]='l';
  ffblk[0].ff_name[252]='l';
  write("JFINDFIRST/NEXT: DLL casing: Not yet supported.\n");
  return 1;

  /*** DOS CASING ***/
  default:
  ffblk[0].ff_name[250]='d';
  ffblk[0].ff_name[251]='o';
  ffblk[0].ff_name[252]='s';
  return findfirst(str,ffblk,attrib);
 }
}

int jfindnext(struct ffblk *ffblk)
{
 //
 int i;
 char str[255],str2[255];

 // DOS casing?
 if( ffblk[0].ff_name[250]=='d' &&
     ffblk[0].ff_name[251]=='o' &&
     ffblk[0].ff_name[252]=='s')return findnext(ffblk);

 // DLL casing?
 return 1;
}

/*** jfexist ***/
int jfexist(const char *fname)
{
 //
 char str[255];
 JFILE *_fp;
 int retu=0;

 //
 _fp=jfopen(fname,"rb");
 if(_fp==NULL)
 {
  retu=0;
 }
 else
 {
  jfclose(_fp);
  retu=1;
 }
 return retu;
}

/*** File handling routines, works under Linux ***/
int fexist(const char *_fname)
{
 //
 FILE *_fp;
 int retu=0;
 char str[255];

 //
 _fp=fopen(_fname,"rb");
 if(_fp==NULL)
 {
  retu=0;
 }
 else
 {
  fclose(_fp);
  retu=1;
//  sprintf(str,"fde:%s.",_fname);
//  jtm_messagebuffer(str);
 }
 return retu;
}

int seektomark(unsigned char _mark,FILE *_fp)
{
 /*

   Returns -1 only if end of file reached before specified mark founded.


  */
 register unsigned char _m1;
 do
 {
  if(feof(_fp))
  {
   return -1;
  }
  _m1=fgetc(_fp);
 }while(_m1!=_mark);
 return 0;
}

int seektomarks(unsigned char *mrks,FILE *_fp)
{
 /*

   Returns -1 only if end of file reached before specified mark founded.


  */
 //
 register unsigned char _m1;
 long ad,ad2;

 //
 while(!0)
 {
  if(feof(_fp))
  {
   return -1;
  }
  _m1=fgetc(_fp);
  for(ad=0; ad<strlen(mrks); ad++)if(_m1==mrks[ad])break;
 }
 return 0;
}

// Seek to the end of file
void seektoeol(FILE *_fp)
{
 register unsigned char _m1;
 do
 {
  _m1=fgetc(_fp);
 }while(_m1!=0x0d);
}

// Look out for next mark, without moving buffer forward:
unsigned lnext(FILE *_fp) 
{
 register unsigned char _m1;
 _m1=fgetc(_fp); fseek(_fp,-1,SEEK_CUR);
 return _m1;
}

//Example: chevar("myvars.vba","name1=");
char *chevar(char *_fname,char *_var)
{
 char *_var1;
 FILE *_fp;
 _fp=fopen(_fname,"rb");
 do
 {
  fscanf(_fp,"%s",&_var1);
  if(_var1[strlen(_var1)-1]=='=')
  {
   if(!strcmp(_var1,_var))
   {
    fscanf(_fp,"%s",_var1);
    return _var1;
   }
  }
 }while(!feof(_fp));
 fclose(_fp);
 return NULL; // Return NULL if variable not found
}

void jtm_killspaces(char *stringi)
{
unl:
 if( stringi[strlen(stringi)-1]==' ' )
 {
  stringi[strlen(stringi)-1]=0;
  goto unl;
 }
}

void DumpAscFile(char *filename,void SelectedOutputConsole())
{
 FILE *f,*f2;
 f=fopen(filename,"rb");
 do
 {
#ifdef DJGPP
  cprintf("%c",fgetc(f));
#else // Well, lets try to trick it work under UN*X too :-)
  printf("%c",fgetc(f));
#endif
  //SelectedOutputConsole(fgetc(f));
 }while(!feof(f));
 fclose(f);
}

void jtm_putc(char merkki)
{
 printf("%c",merkki);
}

int jmkdir(char *dirn)
{
 return mkdir(dirn);
}

int jtm_loadbin64(char *_fname,char	*_tab)
{
 FILE	*_fp;
 long	_ad=0,re=0;
 //
 _fp=fopen(_fname,"rb");
 if(_fp==NULL)
 {
  re=1;
  goto nofile;
 }
 do
 {
  _tab[_ad]=fgetc(_fp)/4;
  _ad++;
 }while(!feof(_fp));
 fclose(_fp);
nofile:
 return re;
}

int jtm_loadbin(char	*fname,char	*_tab)
{
 FILE	*fp;
 long	_ad=0,re;
 //
 re=0;
 fp=fopen(fname,"rb");
 if(fp==NULL)
 {
  re=-1;
  goto nofile;
 }
 do
 {
  _tab[_ad]=fgetc(fp);
  _ad++;
 }while(!feof(fp));
 fclose(fp);
nofile:
 return re;
}

int jtm_loadbinao(char	*fname,char	*_tab,unsigned long length)
{
 FILE	*fp;
 long	_ad=0,re;
 //
 re=0;
 fp=fopen(fname,"rb");
 if(fp==NULL)
 {
  re=-1;
  goto nofile;
 }
 do
 {
  if(_ad>=length)break;
  _tab[_ad]=fgetc(fp);
  _ad++;
 }while(!feof(fp));
 fclose(fp);
nofile:
 return re;
}

unsigned	jtm_loadbinc64(char *_fname,char	*_tab)
{
 FILE	*_fp;
 long	_ad=0,re=0;
 long	a1,a2,a3,a4;
 //
// goto avoidit;
 _fp=fopen(_fname,"rb");
 a1=fgetc(_fp); a2=fgetc(_fp);
 a3=(a2<<8)|a1;
 if(_fp==NULL)
 {
  re=1;
  goto nofile;
 }
 do
 {
  _tab[_ad]=fgetc(_fp);
  _ad++;
 }while(!feof(_fp));
 fclose(_fp);
nofile:
avoidit:
 return re;
}

int jtm_savebin(char	*_fname,unsigned char *_tab,long	length)
{
 FILE	*_fp;
 long	_ad=0,re=0;
 //
 _ad=0;
 _fp=fopen(_fname,"wb");
 if(_fp==NULL)
 {
  re=1;
  goto nofile;
 }
 do
 {
  fputc(_tab[_ad],_fp);
  _ad++;
 }while(_ad<length);
 fclose(_fp);
nofile:
 return re;
}

int jtm_savebinc64(char	*_fname,unsigned char *_tab,long	length,unsigned address)
{
 FILE	*_fp;
 long	_ad=0,re=0;
 //
 re=0;
 _ad=0;
 _fp=fopen(_fname,"wb");
 if(_fp==NULL)
 {
  re=1;
  goto nofile;
 }
 fputc(address&0xff,_fp);
 fputc(address>>8,_fp);
 do
 {
  fputc(_tab[_ad],_fp);
  _ad++;
 }while(_ad<length);
 fclose(_fp);
nofile:
 return re;
}

int jtm_loadbinary(char	*_fname,char *_tab)
{
 FILE	*_fp;
 long	_ad=0;
 //
 _fp=fopen(_fname,"rb");
 do
 {
  _tab[_ad]=fgetc(_fp);
  _ad++;
 }while(!feof(_fp));
 fclose(_fp);
 return 0;
}

#ifdef DJGPP
/*

JTM_SETFILEATTR(filename,attribute);       -- DJGPP only!

Description:

The function changes attribute of the file.
This function will be replaced with JTMOS's own function,
but it is now temporarily working under DOS.H(DOS functions).

Example :

        jtm_setfileattr("c:\\jtmos.cfg",_A_NORMAL|_A_RDONLY|_A_SYSTEM);




`_A_NORMAL (0x00)'
     Normal file (no read/write restrictions)

`_A_RDONLY (0x01)'
     Read only file

`_A_HIDDEN (0x02)'
     Hidden file

`_A_SYSTEM (0x04)'
     System file

`_A_VOLID (0x08)'
     Volume ID file

`_A_SUBDIR (0x10)'
     Subdirectory

`_A_ARCH (0x20)'
     Archive file
*/
unsigned int jtm_setfileattr(const char *filename,unsigned int attr)
{
 _dos_setfileattr(filename,attr);
}
#endif

#ifdef DJGPP
#include <dir.h>
long jtm_dirtofile(unsigned char *ryhma,unsigned char *fname)
{
 //
 long amount;
 int done;
 struct ffblk fdir;
 FILE *f,*f2;

 //
 amount=0;
 done=findfirst(ryhma,&fdir,0x0);
 f=fopen(fname,"wb");
 while(!done)
 {
  fprintf(f,"%s\n",fdir.ff_name);
  amount++;
  done=findnext(&fdir);
 }
 fprintf(f,"**\n");
 fclose(f);
 return amount;
}

long jtm_dirtobuf(unsigned char *ryhma,unsigned char *buf)
{
 //
 long amount;
 int done;
 struct ffblk fdir;
 FILE *f,*f2;
 char str[255],str2[255];

 //
 amount=0;
 done=findfirst(ryhma,&fdir,FA_ARCH|FA_RDONLY);
 while(!done)
 {
  (char*)buf[amount]=malloc(strlen(fdir.ff_name)+2);
  strcpy((char*)buf[amount],fdir.ff_name);
  amount++;
  done=findnext(&fdir);
 }
 return amount;
}

void jtm_reldirbuf(char *buf,long amount)
{
 //
 long ad,ad2;

 //
 for(ad=0; ad<amount; ad++)
 {
  free(buf[ad]);
 }
}

/*
 * Before using function, allways remember to put f.e. "c:" at the beginning
 */

unsigned	char jgetosdrive()
{
 FILE	*_fp;
 unsigned char	_driveletter;
 //
 _fp=fopen(jtmos_cfg,"rb");
 _driveletter=fgetc(_fp);
 fclose(_fp);
 return _driveletter;
}
#endif

int jtm_chdir(char *path)
{
 return chdir(path);
}

void jchdir(char *path)
{
 char str[255];

 jtm_translatefilename(path,str);
 return chdir(str);
}

long fchksum32(char *fname)
{
 //
 char str[255];
 unsigned long ad;
 FILE *fp;

 //
 ad=0;
 fp=fopen(fname,"rb");
 if(fp==NULL)return -1;
 do
 {
  ad=fgetc(fp)+ad;
 }while(!feof(fp));
 fclose(fp);
 return ad;
}

// Translatefilename function,
// Return values are following :
// 0: If old filename=new filename (No change)
// 1: Drive points to a path converted
// 2: Drive points to a DLL
int jtm_translatefilename(char *ofname,char *nfname) // OLD -> NEW
{
 //
 long ad,ad2,ad3,ad4;
 char str[255],str2[255],str3[255],str4[255];

 //
 for(ad=0,ad2=0; ad<strlen(ofname); ad++)
 {
  if(ofname[ad]==':')
  {
   if(ad>=2)ad2=1;
   break;
  }
 }

 // If no drive letter.
 if(!ad2)
 {
casing:
  strcpy(nfname,ofname);
  return 0;
 }
 else
 {
  for(ad=0,ad2=0; ad<strlen(ofname); ad++)
  {
   if(ofname[ad]==':')break;
   str[ad2]=ofname[ad];
   ad2++;
  }
  str[ad2]=0;
  ad3=0;
  ad++;
  while(!0)
  {
   if(!ofname[ad])break;
   str4[ad3]=ofname[ad];
   ad3++; ad++;
  }
  str4[ad3]=0;
  // YES!! STR4 has now the rest of filename ->    xxxx:filename
  //                                               vvvv ^^^str4^

  //
  for(ad=0; ad<jtmextfil.drvamount; ad++)
  {
   if(!strcmp(str,jtmextfil.drvlst[ad]))
   {
    // DLL case
    if(jtmextfil.drvinf[ad][0]=='\"')
    {
     strcpy(nfname,jtmextfil.drvinf[ad]);
     return 2;
    }

    // Get new path
    strcpy(str2,jtmextfil.drvinf[ad]);
    strcat(str2,str4);
    strcpy(nfname,str2);
    return 1;
   }
  }
  goto casing;
 }
}

// JTM_CHECKDLL function
// Action: The function makes a check in DLL system registry.
// If it founds an active and registed DLL named same as specified
// DLL, it'll return non zero(Just like strcmp f.e.).
// The DLL must be located at exactly same location(path),
// or otherways it'll not recognize it exactly same,
// even if it would match in byte compare.
jtm_checkdll(char *fname)
{
 //
 long ad,ad2,ad3,ad4;

 //

}

// Cut'n'shorten. Removes first and last mark from the string so that
// that the string length in destination string is two marks less than
// in the source string.
jtm_cutnshorten(const char *str,char *str2)
{
 //
 long i,i2;

 //
 for(i=0,i2=0; i<strlen(str); i++)
 {
  if(i && i<(strlen(str)-2))
  {
   str2[i2]=str[i];
   i2++;
  }
 }
 str2[i2]=0;
}

//
int jdll_getamount()
{
 return jdllreg.amount;
}

//
char *jdll_getentry(int which)
{
 if(which>jdllreg.amount)return NULL;
 return jdllreg.fname[which];
}

//
struct DLL *jdll_load(const char *filename)
{
 //
 char str[255],str2[255];
 int i,i2;

 // Already existing DLL?
 for(i=0; i<jdllreg.amount; i++)
 {
  if(!strcmp(filename,jdllreg.fname[i]))
  {
   return jdllreg.funct[i];
  }
 }

 //
 jdllreg.fname[jdllreg.amount]=malloc(256);
 strcpy(jdllreg.fname[jdllreg.amount],filename);

 //
 jtm_translatefilename(filename,str);

 //
#ifdef DLL_INCLUDED
 jdllreg.funct[jdllreg.amount]=dll_load(str);
#endif

 //
// write("[DLL LOAD] "); write(filename); write("\n");
// write("[........] "); write(str); write("\n");

 //
 jdllreg.amount=jdllreg.amount+1;

 //
 sprintf(str2,"JDLL_LOAD: Amount = %u\n",jdllreg.amount);
 write(str2);

 //
 return jdllreg.funct[jdllreg.amount-1];
}


/*** BEGINNING OF JFILE FUNCTIONS ***/
// *****************************************************************
//
//  Quick file manipulating functions(Will be later modified alot).
//
// *****************************************************************
//
int jfeof(JFILE *file)
{
 return feof(file[0].file);
}

//
//
int jtm_findjefpos(JTMEXTFIL *_jtmextfil,const char *str)
{
 //
 long i,i2;

 //
 for(i=0,i2=0; i<_jtmextfil[0].drvamount; i++)
 {
  if(!strcmp(_jtmextfil[0].drvinf[i],str))
  {
   i2=1; break;
  }
 }
 if(i2)return i; else return -1;
}

// jfile:fopen
//
JFILE *jfopen(const char *filename, const char *mode)
{
 //
 char str[255],str2[255],str3[255],str4[255],
      ast[255],ast2[255],ast3[255],ast4[255];
 FILE *f;
 JFILE *jf;
 int i,i2,i3,i4;
 JFILE *(*func)(const char *__filename,const char *__mode);
 void (*funcinit)();

 // Handle drive
 i4=jtm_translatefilename(filename,str);
// sprintf(str2,"%u - %s\n",i4,str);
// write(str2); waitkey();
 switch( i4 )
 {
  // If it's same
  case 0:
  jf=malloc(sizeof(JFILE));
  //
  jf[0].file=fopen(str,mode);
  jf[0].compression=1; // No compression
  jf[0].type=1; // DOS handled
  return jf;

  // If it's changed
  case 1:
  jf=malloc(sizeof(JFILE));
  //
  jf[0].file=fopen(str,mode);
  jf[0].compression=1; // No compression
  jf[0].type=1; // DOS handled
  return jf;

  // If it's DLL based
  case 2:
  // "iojgejergioj" -> iojgejergioj
  jtm_cutnshorten(str,str2);
  // ^^Okay, so now we have got the DLL filename^^

  // Cut drive specifier string from filename like this:
  // foodriver:filename -> foodriver
  for(i=0; i<strlen(filename); i++)
  {
   if(filename[i]==':')break;
   ast[i]=filename[i];
  }
  ast[i]=0;

  // Check if DLL exists, roll over all DRIVES until match to
  // 'ast' drive found.
  i=jtm_findjefpos(&jtmextfil,str);
  //
  if(i!=-1) // ?? DLL
  {
   // DRIVE registed in offset I on jtmextfil registry.
   // Install DLL if doesn't exist, yet.
   if(!jtmextfil.drvdll[i])
   {
    jtmextfil.drvdll[i]=jdll_load(str2);
   }
   if(!jtmextfil.drvdll[i])
   {
    jtm_messagebuffer("Error while loading DLL.");
    goto terridll;
   }

   //
#ifdef DLL_INCLUDED
   funcinit=(void (*)())dll_lookup(jtmextfil.drvdll[i], "_initdll");
#endif
   if(funcinit)
   {
    funcinit();
   }
   else
   {
    jtm_messagebuffer("Error while DLL init.");
    goto terridll;
   }

   // Call DLL's dll_jfopen function.
#ifdef DLL_INCLUDED
   func=(JFILE *(*)(int,int))dll_lookup(jtmextfil.drvdll[i], "_dll_jfopen");
#endif
   if(func)
   {
    return func(filename,mode);
   }
   else
   {
terridll:
    jtm_messagebuffer("ERROR: UNABLE TO HANDLE JFOPEN CALL. - PAR :");
    jtm_messagebuffer(str2);
    return NULL;
   }
  }
  else
  {
   write("BOING ZHU THA .. Drive not found !\n");
   write("Impossible, this was never meant to happend.\n");
   write("Should I call this an error message? I do not know, sorry, :>\n");
   waitkey();
   return NULL;
  }
  return NULL;

  //
  default:
  return NULL;
 }
}

//
int jfclose(JFILE *file)
{
 //
 int reval;

 //
 switch(file[0].type)
 {
  //
  case 1:
  reval=fclose(file[0].file);
  free(file);
  break;
  //
  case 2:
  break;
 }
 return reval;
}

//
char *jfgets(char *buffer, int maxlength, JFILE *file)
{
 return fgets(buffer,maxlength,file[0].file);
}

int jfputs(const char *string, JFILE *file)
{
 return fputs(string,file[0].file);
}

//
int jfgetc(JFILE *file)
{
 return fgetc(file[0].file);
}

//
int jfputc(int character, JFILE *file)
{
 return fputc(character,file[0].file);
}

//
int jfseek(JFILE *file, long offset, int mode)
{
 return fseek(file[0].file,offset,mode);
}
/**** END OF JFILE FUNCTIONS ****/





// JTM_INITEXTFIL - Initializes Extended Filing System
// (Adds some drives to the file system)
jtm_initextfil(JTMEXTFIL *_jtmextfil)
{
 //
 char str[255],str2[255],str3[255],str4[255];
 long ad,ad2,ad3,ad4;

 //
 _jtmextfil[0].state=1;
 _jtmextfil[0].drvamount=jgetenvgroupmemberlist("drives",_jtmextfil[0].drvlst);

 // Load Device drives / Get mirrorred path targets
 for(ad=0; ad<_jtmextfil[0].drvamount; ad++)
 {
  sprintf(str,"%s=",_jtmextfil[0].drvlst[ad]);
  strcpy(str2,jgetenv("drives",str));
#ifdef DEBUG_INITEXTFIL
  write(str); write(str2); write("\n"); waitkey();
#endif
  switch(str2[0])
  {
   // A device driver based drive ?
   case '\"':
   // -Ahh, not yet done <:)
   _jtmextfil[0].drvtyp[ad]=2;
   _jtmextfil[0].drvinf[ad]=malloc(256);
   strcpy(_jtmextfil[0].drvinf[ad],str2);
   break;

   // A mirror path ?
   default:
   _jtmextfil[0].drvtyp[ad]=1;
   _jtmextfil[0].drvinf[ad]=malloc(256);
   strcpy(_jtmextfil[0].drvinf[ad],str2);
   break;
  }
 }
}

//
int jtm_shutdownextfil(JTMEXTFIL *_jtmextfil)
{
 //
 long ad,ad2,ad3,ad4;

 //
 if(_jtmextfil[0].state)
 {
  for(ad=0; ad<_jtmextfil[0].drvamount; ad++)
  {
   switch(_jtmextfil[0].drvtyp[ad])
   {
    // Drive is a Path Mirror based
    case 1:
    free(_jtmextfil[0].drvlst[ad]); // Free Name
    free(_jtmextfil[0].drvinf[ad]); // Free Mirror Path string
    break;
    // Drive is a Driver based
    case 2:
    free(_jtmextfil[0].drvlst[ad]); // Free Name
    free(_jtmextfil[0].drvdll[ad]); // Free DLL
    break;
    //
    default:
    break;
   }
  }
  // Mission completed ! d:)
  _jtmextfil[0].state=0;
  return 0;
 }
 else
 {
  return -1;
 }
}

